import { ElementRef, EventEmitter, OnInit, TemplateRef } from '@angular/core';
import { NgbModal, NgbOffcanvas } from '@ng-bootstrap/ng-bootstrap';
import { Message } from "typehub-javascript-sdk";
import { Specification } from "../model/Specification";
import { Type } from "../model/Type";
import { Property } from "../model/Property";
import { Include } from "../model/Include";
import { ImportService, SchemaType } from "../import.service";
import { Operation } from "../model/Operation";
import { Throw } from "../model/Throw";
import { ViewportScroller } from "@angular/common";
import { Security } from "../model/Security";
import { BCLayerService } from "../bclayer.service";
import { ResolverService } from "../resolver.service";
import * as i0 from "@angular/core";
export declare class EditorComponent implements OnInit {
    private importService;
    private resolverService;
    private bcLayerService;
    private modalService;
    private offCanvasService;
    private viewportScroller;
    specification: Specification;
    operationEnabled: boolean;
    importEnabled: boolean;
    readonly: boolean;
    id: string;
    objectRef?: TemplateRef<any>;
    arrayRef?: TemplateRef<any>;
    mapRef?: TemplateRef<any>;
    stringRef?: TemplateRef<any>;
    integerRef?: TemplateRef<any>;
    numberRef?: TemplateRef<any>;
    booleanRef?: TemplateRef<any>;
    save: EventEmitter<Specification>;
    change: EventEmitter<Specification>;
    operationModalRef: ElementRef;
    typeModalRef: ElementRef;
    operation: Operation;
    throw: Throw;
    type: Type;
    children: Array<string>;
    generics: Array<string>;
    property: Property;
    import: string;
    importType: SchemaType;
    export: string;
    selectedType?: number;
    selectedOperation?: number;
    openModal: boolean;
    loading: boolean;
    dirty: boolean;
    response?: Message;
    baseUrl?: string;
    security?: Security;
    contentTypes: Array<{
        name: string;
        value: string;
    }>;
    include: Include;
    constructor(importService: ImportService, resolverService: ResolverService, bcLayerService: BCLayerService, modalService: NgbModal, offCanvasService: NgbOffcanvas, viewportScroller: ViewportScroller);
    ngOnInit(): Promise<void>;
    doSave(): void;
    doChange(): void;
    setRoot(typeIndex: number): void;
    orderOperations(): void;
    openOperation(content: any): void;
    editOperation(content: any, operationIndex: number): void;
    selectOperation(operationIndex: number): void;
    orderTypes(): void;
    openType(content: any): void;
    editType(content: any, typeIndex: number): void;
    deleteTypeMapping(typeIndex: number, mappingKey: string): void;
    selectType(typeIndex: number): void;
    handleKeyboardEvent(event: KeyboardEvent): void;
    findGenerics(type?: Type | null): Array<string>;
    findOperationByName(operationName: string): Operation | null;
    isLinkableType(typeName: string): boolean;
    findTypeByName(typeName: string): Type | null;
    findTypesWithParent(parent?: Type): Array<string>;
    updateDiscriminator(): void;
    updateMapping(): void;
    updateGenerics(): void;
    updatePropertyReference(): void;
    deleteOperation(operationIndex: number): void;
    copyOperation(operationIndex: number): void;
    upArgument(operationIndex: number, argumentIndex: number): void;
    downArgument(operationIndex: number, argumentIndex: number): void;
    deleteArgument(operationIndex: number, argumentIndex: number): void;
    upThrow(operationIndex: number, throwIndex: number): void;
    downThrow(operationIndex: number, throwIndex: number): void;
    deleteThrow(operationIndex: number, throwIndex: number): void;
    deleteType(typeIndex: number): void;
    copyType(typeIndex: number): void;
    upProperty(typeIndex: number, propertyIndex: number): void;
    downProperty(typeIndex: number, propertyIndex: number): void;
    openProperty(content: any, typeIndex: number): void;
    editProperty(content: any, typeIndex: number, propertyIndex: number): void;
    deleteProperty(typeIndex: number, propertyIndex: number): void;
    deleteInclude(includeIndex: number): void;
    openSettings(content: any): void;
    openInclude(content: any): void;
    openImport(content: any): void;
    openExport(content: any): void;
    openToc(content: any): void;
    loadFromLocalStorage(): void;
    saveToLocalStorage(): void;
    private getLocalStorageName;
    private isEmptySpecification;
    static ɵfac: i0.ɵɵFactoryDeclaration<EditorComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<EditorComponent, "typeschema-editor", never, { "specification": { "alias": "specification"; "required": false; }; "operationEnabled": { "alias": "operationEnabled"; "required": false; }; "importEnabled": { "alias": "importEnabled"; "required": false; }; "readonly": { "alias": "readonly"; "required": false; }; "id": { "alias": "id"; "required": false; }; "objectRef": { "alias": "objectRef"; "required": false; }; "arrayRef": { "alias": "arrayRef"; "required": false; }; "mapRef": { "alias": "mapRef"; "required": false; }; "stringRef": { "alias": "stringRef"; "required": false; }; "integerRef": { "alias": "integerRef"; "required": false; }; "numberRef": { "alias": "numberRef"; "required": false; }; "booleanRef": { "alias": "booleanRef"; "required": false; }; }, { "save": "save"; "change": "change"; }, never, never, false, never>;
}
