import { Specification } from "../model/Specification";
import { TypeHubService } from "../typehub.service";
import { Type } from "../model/Type";
import { TransformerInterface } from "./TransformerInterface";
import { ResolverService } from "../resolver.service";
export declare class TypeSchema implements TransformerInterface {
    protected typeHubService: TypeHubService;
    protected resolverService: ResolverService;
    anonymousObjects: Record<string, any>;
    protected scalarTypes: string[];
    constructor(typeHubService: TypeHubService, resolverService: ResolverService);
    transform(schema: string): Promise<Specification>;
    protected build(data: Record<string, any>): Promise<Specification>;
    private transformImport;
    protected transformType(name: string, data: Record<string, any>): Promise<Type>;
    private transformProperty;
    protected parseRef(data: any): string;
    protected isset(value: any): boolean;
    protected get(object: any, keys: Array<string>): any;
    protected normalizeRef(ref: string): string;
    protected hash(data: string): Promise<string>;
}
